#ifndef EMS_VECTOR
#define EMS_VECTOR

/*
   NAME: ems_vector.cpp
   SINN:
   //
   INFO:
*/


//#include "ems_exception.h"

#include <valarray>

/***********************************************************/

namespace EMS {

/////////////////////////////////////////////////////////////


/* #[ class VectorT1<> : */
template<class T> class VectorT1
{
private:

    mutable  std::valarray<T>  mData;   // value_t  valarray::operator[](...) const
	
public:

    typedef  T          value_t;
    typedef  T *        iterator;
    typedef  T const *  const_iterator;


                      VectorT1( unsigned int  _size =0 )
                              :
                                mData(_size)
                              {}

    unsigned int          size( void ) const             { return  mData.size();          }
    void                resize( unsigned int  _size )    {         mData.resize( _size ); }

    iterator             begin( void )                   { return  & mData[ 0 ]; }
    const_iterator       begin( void ) const             { return  & mData[ 0 ]; }     

    iterator               end( void )                   { return  begin() + size(); }
    const_iterator         end( void ) const             { return  begin() + size(); }

    T &             operator[]( unsigned int  _i )       { return  mData[ _i ]; }
    T const &       operator[]( unsigned int  _i ) const { return  mData[ _i ]; }

//  T &                     at( unsigned int  _i )       { if( _i >= size() ) throw BadIdEX("EMS::VectorT1::at"); return  mData[ _i ]; } 
//  T const &               at( unsigned int  _i ) const { if( _i >= size() ) throw BadIdEX("EMS::VectorT1::at"); return  mData[ _i ]; } 
};
/* #]  : */

/**/
/**/

/* #[ class VectorT2<> : */
/*
  solange alles inline ist, macht base-class eigentlich keinen groen Sinn
  und strt sogar bei "T const *" (bruchte "void const *")
*/
/* #[ class VectorT2_base : */
class VectorT2_base
{
protected:

    void *        mData_p;
    unsigned int  mSize;


    VectorT2_base( void * const  v_pc,  unsigned int  _size )
	:
	  mData_p(v_pc)
	, mSize  (_size)
    {}
};
/* #]  : */

/**/

/* #[ class VectorT2<> : */
template<class T> struct VectorT2 : private VectorT2_base
{
    typedef  T          value_t;
    typedef  T *        iterator;
    typedef  T const *  const_iterator;


                      VectorT2( T * const  t_pc =0,  unsigned int  _size =0 ) : VectorT2_base(t_pc, _size) {}

    unsigned int          size( void )             const { return  mSize; }
    void                resize( T * const  t_pc,  unsigned int  _size )
                              {
                                  mData_p  =  t_pc;
                                  mSize    =  _size;
                              }

    void                resize( T * const  t_pc )        { mData_p  =  t_pc;  }
    void                resize( unsigned int  _size )    { mSize    =  _size; }

    iterator             begin( void )                   { return  static_cast<T *>      ( mData_p ); }
    const_iterator       begin( void )             const { return  static_cast<T const *>( mData_p ); }

    iterator               end( void )                   { return  begin() + mSize; }
    const_iterator         end( void )             const { return  begin() + mSize; }

    T &             operator[]( unsigned int  _i )       { return  begin()[ _i ]; }
    T const &       operator[]( unsigned int  _i ) const { return  begin()[ _i ]; }

//  T &                     at( unsigned int  _i )       { if( _i >= mSize ) throw BadIdEX("EMS::VectorT2::at"); return  begin()[ _i ]; } 
//  T const &               at( unsigned int  _i ) const { if( _i >= mSize ) throw BadIdEX("EMS::VectorT2::at"); return  begin()[ _i ]; } 
};
/* #]  : */

/* #]  : */


/////////////////////////////////////////////////////////////

} // namespace EMS

/***********************************************************/

#endif // EMS_VECTOR
